Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.logging.log4j.spi
Class AbstractLogger

    java.lang.Object
      org.apache.logging.log4j.spi.AbstractLogger

All Implemented Interfaces:
  Serializable, Logger, ExtendedLogger

Direct Known Subclasses:
  ExtendedLoggerWrapper, SimpleLogger, StatusLogger

    public abstract class AbstractLogger

extends Object
implements ExtendedLogger, Serializable

Base implementation of a Logger. It is highly recommended that any Logger implementation extend this class.

See Also:
  Serialized Form

Field Summary
`static Marker` | `CATCHING_MARKER` Marker for catching exceptions.
`static Class<? extends MessageFactory>` | `DEFAULT_MESSAGE_FACTORY_CLASS` The default MessageFactory class.
`static Marker` | `ENTRY_MARKER` Marker for method entry tracing.
`static Marker` | `EXCEPTION_MARKER` Marker for exception tracing.
`static Marker` | `EXIT_MARKER` Marker for method exit tracing.
`static Marker` | `FLOW_MARKER` Marker for flow tracing.
`static Marker` | `THROWING_MARKER` Marker for throwing exceptions.

Constructor Summary
`AbstractLogger()` Creates a new logger named after this class (or subclass).
`AbstractLogger(String name)` Creates a new named logger.
`AbstractLogger(String name, MessageFactory messageFactory)` Creates a new named logger with a particular `MessageFactory`.

Method Summary
`void` | `catching(Level level, Throwable t)` Logs an exception or error that has been caught to a specific logging level.
`protected void` | `catching(String fqcn, Level level, Throwable t)` Logs a Throwable that has been caught with location information.
`void` | `catching(Throwable t)` Logs an exception or error that has been caught.
`protected Message` | `catchingMsg(Throwable t)`
`static void` | `checkMessageFactory(ExtendedLogger logger, MessageFactory messageFactory)` Checks that the message factory a logger was created with is the same as the given messageFactory.
`void` | `debug(Marker marker, Message msg)` Logs a message with the specific Marker at the `DEBUG` level.
`void` | `debug(Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the `DEBUG` level.
`void` | `debug(Marker marker, Object message)` Logs a message object with the `DEBUG` level.
`void` | `debug(Marker marker, Object message, Throwable t)` Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `debug(Marker marker, String message)` Logs a message object with the `DEBUG` level.
`void` | `debug(Marker marker, String message, Object... params)` Logs a message with parameters at the `DEBUG` level.
`void` | `debug(Marker marker, String message, Throwable t)` Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `debug(Message msg)` Logs a message with the specific Marker at the `DEBUG` level.
`void` | `debug(Message msg, Throwable t)` Logs a message with the specific Marker at the `DEBUG` level.
`void` | `debug(Object message)` Logs a message object with the `DEBUG` level.
`void` | `debug(Object message, Throwable t)` Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `debug(String message)` Logs a message object with the `DEBUG` level.
`void` | `debug(String message, Object... params)` Logs a message with parameters at the `DEBUG` level.
`void` | `debug(String message, Throwable t)` Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `entry()` Logs entry to a method.
`void` | `entry(Object... params)` Logs entry to a method along with its parameters.
`protected void` | `entry(String fqcn, Object... params)` Logs entry to a method with location information.
`protected Message` | `entryMsg(int count, Object... params)`
`void` | `error(Marker marker, Message msg)` Logs a message with the specific Marker at the `ERROR` level.
`void` | `error(Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the `ERROR` level.
`void` | `error(Marker marker, Object message)` Logs a message object with the `ERROR` level.
`void` | `error(Marker marker, Object message, Throwable t)` Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `error(Marker marker, String message)` Logs a message object with the `ERROR` level.
`void` | `error(Marker marker, String message, Object... params)` Logs a message with parameters at the `ERROR` level.
`void` | `error(Marker marker, String message, Throwable t)` Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `error(Message msg)` Logs a message with the specific Marker at the `ERROR` level.
`void` | `error(Message msg, Throwable t)` Logs a message with the specific Marker at the `ERROR` level.
`void` | `error(Object message)` Logs a message object with the `ERROR` level.
`void` | `error(Object message, Throwable t)` Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `error(String message)` Logs a message object with the `ERROR` level.
`void` | `error(String message, Object... params)` Logs a message with parameters at the `ERROR` level.
`void` | `error(String message, Throwable t)` Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `exit()` Logs exit from a method.
`
`<R> R`
` | `exit(R result)` Logs exiting from a method with the result.
`protected
`<R> R`
` | `exit(String fqcn, R result)` Logs exiting from a method with the result and location information.
`protected Message` | `exitMsg(Object result)`
`void` | `fatal(Marker marker, Message msg)` Logs a message with the specific Marker at the `FATAL` level.
`void` | `fatal(Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the `FATAL` level.
`void` | `fatal(Marker marker, Object message)` Logs a message object with the `FATAL` level.
`void` | `fatal(Marker marker, Object message, Throwable t)` Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `fatal(Marker marker, String message)` Logs a message object with the `FATAL` level.
`void` | `fatal(Marker marker, String message, Object... params)` Logs a message with parameters at the `FATAL` level.
`void` | `fatal(Marker marker, String message, Throwable t)` Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `fatal(Message msg)` Logs a message with the specific Marker at the `FATAL` level.
`void` | `fatal(Message msg, Throwable t)` Logs a message with the specific Marker at the `FATAL` level.
`void` | `fatal(Object message)` Logs a message object with the `FATAL` level.
`void` | `fatal(Object message, Throwable t)` Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `fatal(String message)` Logs a message object with the `FATAL` level.
`void` | `fatal(String message, Object... params)` Logs a message with parameters at the `FATAL` level.
`void` | `fatal(String message, Throwable t)` Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.
`MessageFactory` | `getMessageFactory()` Gets the message factory used to convert message Objects and Strings into actual log Messages.
`String` | `getName()` Gets the logger name.
`void` | `info(Marker marker, Message msg)` Logs a message with the specific Marker at the `INFO` level.
`void` | `info(Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the `INFO` level.
`void` | `info(Marker marker, Object message)` Logs a message object with the `INFO` level.
`void` | `info(Marker marker, Object message, Throwable t)` Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `info(Marker marker, String message)` Logs a message object with the `INFO` level.
`void` | `info(Marker marker, String message, Object... params)` Logs a message with parameters at the `INFO` level.
`void` | `info(Marker marker, String message, Throwable t)` Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `info(Message msg)` Logs a message with the specific Marker at the `INFO` level.
`void` | `info(Message msg, Throwable t)` Logs a message with the specific Marker at the `INFO` level.
`void` | `info(Object message)` Logs a message object with the `INFO` level.
`void` | `info(Object message, Throwable t)` Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `info(String message)` Logs a message object with the `INFO` level.
`void` | `info(String message, Object... params)` Logs a message with parameters at the `INFO` level.
`void` | `info(String message, Throwable t)` Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.
`boolean` | `isDebugEnabled()` Checks whether this Logger is enabled for the `DEBUG` Level.
`boolean` | `isDebugEnabled(Marker marker)` Checks whether this Logger is enabled for the `DEBUG` Level.
`boolean` | `isEnabled(Level level)` Checks whether this Logger is enabled for the the given Level.
`boolean` | `isEnabled(Level level, Marker marker)` Checks whether this logger is enabled at the specified level and an optional Marker.
`boolean` | `isErrorEnabled()` Checks whether this Logger is enabled for the `ERROR` Level.
`boolean` | `isErrorEnabled(Marker marker)` Checks whether this Logger is enabled for the `ERROR` Level.
`boolean` | `isFatalEnabled()` Checks whether this Logger is enabled for the `FATAL` Level.
`boolean` | `isFatalEnabled(Marker marker)` Checks whether this Logger is enabled for the `FATAL` Level.
`boolean` | `isInfoEnabled()` Checks whether this Logger is enabled for the `INFO` Level.
`boolean` | `isInfoEnabled(Marker marker)` Checks whether this Logger is enabled for the `INFO` Level.
`boolean` | `isTraceEnabled()` Checks whether this Logger is enabled for the `TRACE` level.
`boolean` | `isTraceEnabled(Marker marker)` Checks whether this Logger is enabled for the `TRACE` level.
`boolean` | `isWarnEnabled()` Checks whether this Logger is enabled for the `WARN` Level.
`boolean` | `isWarnEnabled(Marker marker)` Checks whether this Logger is enabled for the `WARN` Level.
`void` | `log(Level level, Marker marker, Message msg)` Logs a message with the specific Marker at the given level.
`void` | `log(Level level, Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the given level.
`void` | `log(Level level, Marker marker, Object message)` Logs a message object with the given level.
`void` | `log(Level level, Marker marker, Object message, Throwable t)` Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `log(Level level, Marker marker, String message)` Logs a message object with the given level.
`void` | `log(Level level, Marker marker, String message, Object... params)` Logs a message with parameters at the given level.
`void` | `log(Level level, Marker marker, String message, Throwable t)` Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `log(Level level, Message msg)` Logs a message with the specific Marker at the given level.
`void` | `log(Level level, Message msg, Throwable t)` Logs a message with the specific Marker at the given level.
`void` | `log(Level level, Object message)` Logs a message object with the given level.
`void` | `log(Level level, Object message, Throwable t)` Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `log(Level level, String message)` Logs a message object with the given level.
`void` | `log(Level level, String message, Object... params)` Logs a message with parameters at the given level.
`void` | `log(Level level, String message, Throwable t)` Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `logIfEnabled(String fqcn, Level level, Marker marker, Message msg, Throwable t)` Logs a message if the specified level is active.
`void` | `logIfEnabled(String fqcn, Level level, Marker marker, Object message, Throwable t)` Logs a message if the specified level is active.
`void` | `logIfEnabled(String fqcn, Level level, Marker marker, String message)` Logs a message if the specified level is active.
`void` | `logIfEnabled(String fqcn, Level level, Marker marker, String message, Object... params)` Logs a message if the specified level is active.
`void` | `logIfEnabled(String fqcn, Level level, Marker marker, String message, Throwable t)` Logs a message if the specified level is active.
`protected void` | `logMessage(String fqcn, Level level, Marker marker, Object message, Throwable t)`
`protected void` | `logMessage(String fqcn, Level level, Marker marker, String message)`
`protected void` | `logMessage(String fqcn, Level level, Marker marker, String message, Object... params)`
`protected void` | `logMessage(String fqcn, Level level, Marker marker, String message, Throwable t)`
`void` | `printf(Level level, Marker marker, String format, Object... params)` Logs a formatted message using the specified format string and arguments.
`void` | `printf(Level level, String format, Object... params)` Logs a formatted message using the specified format string and arguments.
`
`<T extends Throwable> T`
` | `throwing(Level level, T t)` Logs an exception or error to be thrown.
`protected
`<T extends Throwable> T`
` | `throwing(String fqcn, Level level, T t)` Logs a Throwable to be thrown.
`
`<T extends Throwable> T`
` | `throwing(T t)` Logs an exception or error to be thrown.
`protected Message` | `throwingMsg(Throwable t)`
`void` | `trace(Marker marker, Message msg)` Logs a message with the specific Marker at the `TRACE` level.
`void` | `trace(Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the `TRACE` level.
`void` | `trace(Marker marker, Object message)` Logs a message object with the `TRACE` level.
`void` | `trace(Marker marker, Object message, Throwable t)` Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `trace(Marker marker, String message)` Logs a message object with the `TRACE` level.
`void` | `trace(Marker marker, String message, Object... params)` Logs a message with parameters at the `TRACE` level.
`void` | `trace(Marker marker, String message, Throwable t)` Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `trace(Message msg)` Logs a message with the specific Marker at the `TRACE` level.
`void` | `trace(Message msg, Throwable t)` Logs a message with the specific Marker at the `TRACE` level.
`void` | `trace(Object message)` Logs a message object with the `TRACE` level.
`void` | `trace(Object message, Throwable t)` Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `trace(String message)` Logs a message object with the `TRACE` level.
`void` | `trace(String message, Object... params)` Logs a message with parameters at the `TRACE` level.
`void` | `trace(String message, Throwable t)` Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `warn(Marker marker, Message msg)` Logs a message with the specific Marker at the `WARN` level.
`void` | `warn(Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the `WARN` level.
`void` | `warn(Marker marker, Object message)` Logs a message object with the `WARN` level.
`void` | `warn(Marker marker, Object message, Throwable t)` Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `warn(Marker marker, String message)` Logs a message object with the `WARN` level.
`void` | `warn(Marker marker, String message, Object... params)` Logs a message with parameters at the `WARN` level.
`void` | `warn(Marker marker, String message, Throwable t)` Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `warn(Message msg)` Logs a message with the specific Marker at the `WARN` level.
`void` | `warn(Message msg, Throwable t)` Logs a message with the specific Marker at the `WARN` level.
`void` | `warn(Object message)` Logs a message object with the `WARN` level.
`void` | `warn(Object message, Throwable t)` Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `warn(String message)` Logs a message object with the `WARN` level.
`void` | `warn(String message, Object... params)` Logs a message with parameters at the `WARN` level.
`void` | `warn(String message, Throwable t)` Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.logging.log4j.spi.ExtendedLogger
`isEnabled, isEnabled, isEnabled, isEnabled, isEnabled, logMessage`

Methods inherited from interface org.apache.logging.log4j.Logger
`getLevel`

Field Detail

### FLOW_MARKER

    public static final Marker FLOW_MARKER

  Marker for flow tracing.

### ENTRY_MARKER

    public static final Marker ENTRY_MARKER

  Marker for method entry tracing.

### EXIT_MARKER

    public static final Marker EXIT_MARKER

  Marker for method exit tracing.

### EXCEPTION_MARKER

    public static final Marker EXCEPTION_MARKER

  Marker for exception tracing.

### THROWING_MARKER

    public static final Marker THROWING_MARKER

  Marker for throwing exceptions.

### CATCHING_MARKER

    public static final Marker CATCHING_MARKER

  Marker for catching exceptions.

### DEFAULT_MESSAGE_FACTORY_CLASS

    public static final Class<? extends MessageFactory> DEFAULT_MESSAGE_FACTORY_CLASS

  The default MessageFactory class.

Constructor Detail

### AbstractLogger

    public AbstractLogger()

  Creates a new logger named after this class (or subclass).

### AbstractLogger

    public AbstractLogger(String name)

  Creates a new named logger.

  Parameters:
    `name` - the logger name

### AbstractLogger

    public AbstractLogger(String name,
                          MessageFactory messageFactory)

  Creates a new named logger with a particular `MessageFactory`.

  Parameters:
    `name` - the logger name
    `messageFactory` - the message factory, if null then use the default message factory.

Method Detail

### checkMessageFactory

    public static void checkMessageFactory(ExtendedLogger logger,
                                           MessageFactory messageFactory)

  Checks that the message factory a logger was created with is the same as the given messageFactory. If they are different log a warning to the StatusLogger. A null MessageFactory translates to the default MessageFactory `DEFAULT_MESSAGE_FACTORY_CLASS`.

  Parameters:
    `logger` - The logger to check
    `messageFactory` - The message factory to check.

### catching

    public void catching(Level level,
                         Throwable t)

  Description copied from interface: `Logger`
  Logs an exception or error that has been caught to a specific logging level.

  Specified by:
    `catching` in interface `Logger`
  Parameters:
    `level` - The logging Level.
    `t` - The Throwable.

### catching

    protected void catching(String fqcn,
                            Level level,
                            Throwable t)

  Logs a Throwable that has been caught with location information.

  Parameters:
    `fqcn` - The fully qualified class name of the caller.
    `level` - The logging level.
    `t` - The Throwable.

### catching

    public void catching(Throwable t)

  Description copied from interface: `Logger`
  Logs an exception or error that has been caught. Normally, one may wish to provide additional information with an exception while logging it; in these cases, one would not use this method. In other cases where simply logging the fact that an exception was swallowed somewhere (e.g., at the top of the stack trace in a `main()` method), this method is ideal for it.

  Specified by:
    `catching` in interface `Logger`
  Parameters:
    `t` - The Throwable.

### catchingMsg

    protected Message catchingMsg(Throwable t)

### debug

    public void debug(Marker marker,
                      Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `DEBUG` level.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### debug

    public void debug(Marker marker,
                      Message msg,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `DEBUG` level.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### debug

    public void debug(Marker marker,
                      Object message)

  Description copied from interface: `Logger`
  Logs a message object with the `DEBUG` level.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### debug

    public void debug(Marker marker,
                      Object message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### debug

    public void debug(Marker marker,
                      String message)

  Description copied from interface: `Logger`
  Logs a message object with the `DEBUG` level.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### debug

    public void debug(Marker marker,
                      String message,
                      Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the `DEBUG` level.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `Logger.getMessageFactory()`

### debug

    public void debug(Marker marker,
                      String message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### debug

    public void debug(Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `DEBUG` level.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `msg` - the message string to be logged

### debug

    public void debug(Message msg,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `DEBUG` level.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### debug

    public void debug(Object message)

  Description copied from interface: `Logger`
  Logs a message object with the `DEBUG` level.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `message` - the message object to log.

### debug

    public void debug(Object message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### debug

    public void debug(String message)

  Description copied from interface: `Logger`
  Logs a message object with the `DEBUG` level.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `message` - the message string to log.

### debug

    public void debug(String message,
                      Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the `DEBUG` level.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `Logger.getMessageFactory()`

### debug

    public void debug(String message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `debug` in interface `Logger`
  Parameters:
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### entry

    public void entry()

  Description copied from interface: `Logger`
  Logs entry to a method. Used when the method in question has no parameters or when the parameters should not be logged.

  Specified by:
    `entry` in interface `Logger`

### entry

    public void entry(Object... params)

  Description copied from interface: `Logger`
  Logs entry to a method along with its parameters. For example,

           public void doSomething(String foo, int bar) {
               LOGGER.entry(foo, bar);
               // do something
           }

  The use of methods such as this are more effective when combined with aspect-oriented programming or other bytecode manipulation tools. It can be rather tedious (and messy) to use this type of method manually.

  Specified by:
    `entry` in interface `Logger`
  Parameters:
    `params` - The parameters to the method. TODO Use of varargs results in array creation which can be a substantial portion of no-op case. LogMF/LogSF provides several overrides to avoid vararg except in edge cases. (RG) LogMF and LogSF implement these in LogXF which calls logger.callAppenders. callAppenders is part of the implementation and cannot be used by the API. Adding more methods here and in AbstractLogger is sufficient.

### entry

    protected void entry(String fqcn,
                         Object... params)

  Logs entry to a method with location information.

  Parameters:
    `fqcn` - The fully qualified class name of the caller.
    `params` - The parameters to the method.

### entryMsg

    protected Message entryMsg(int count,
                               Object... params)

### error

    public void error(Marker marker,
                      Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `ERROR` level.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### error

    public void error(Marker marker,
                      Message msg,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `ERROR` level.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### error

    public void error(Marker marker,
                      Object message)

  Description copied from interface: `Logger`
  Logs a message object with the `ERROR` level.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement.
    `message` - the message object to log.

### error

    public void error(Marker marker,
                      Object message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement.
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### error

    public void error(Marker marker,
                      String message)

  Description copied from interface: `Logger`
  Logs a message object with the `ERROR` level.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement.
    `message` - the message object to log.

### error

    public void error(Marker marker,
                      String message,
                      Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the `ERROR` level.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement.
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call. (RG) I assume you meant error, not info. It isn't possible to be misinterpreted as the previous method is for that signature. Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### error

    public void error(Marker marker,
                      String message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement.
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### error

    public void error(Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `ERROR` level.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `msg` - the message string to be logged

### error

    public void error(Message msg,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `ERROR` level.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### error

    public void error(Object message)

  Description copied from interface: `Logger`
  Logs a message object with the `ERROR` level.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `message` - the message object to log.

### error

    public void error(Object message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### error

    public void error(String message)

  Description copied from interface: `Logger`
  Logs a message object with the `ERROR` level.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `message` - the message string to log.

### error

    public void error(String message,
                      Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the `ERROR` level.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call. (RG) I assume you meant error, not info. It isn't possible to be misinterpreted as the previous method is for that signature. Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### error

    public void error(String message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `error` in interface `Logger`
  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### exit

    public void exit()

  Description copied from interface: `Logger`
  Logs exit from a method. Used for methods that do not return anything.

  Specified by:
    `exit` in interface `Logger`

### exit

    public <R> R exit(R result)

  Description copied from interface: `Logger`
  Logs exiting from a method with the result. This may be coded as:

           return LOGGER.exit(myResult);

  Specified by:
    `exit` in interface `Logger`
  Type Parameters:
    `R` - The type of the parameter and object being returned.
  Parameters:
    `result` - The result being returned from the method call.
  Returns:
    the result.

### exit

    protected <R> R exit(String fqcn,
                         R result)

  Logs exiting from a method with the result and location information.

  Type Parameters:
    `R` - The type of the parameter and object being returned.
  Parameters:
    `fqcn` - The fully qualified class name of the caller.
    `result` - The result being returned from the method call.
  Returns:
    the return value passed to this method.

### exitMsg

    protected Message exitMsg(Object result)

### fatal

    public void fatal(Marker marker,
                      Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `FATAL` level.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### fatal

    public void fatal(Marker marker,
                      Message msg,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `FATAL` level.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### fatal

    public void fatal(Marker marker,
                      Object message)

  Description copied from interface: `Logger`
  Logs a message object with the `FATAL` level.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `marker` - The marker data specific to this log statement.
    `message` - the message object to log.

### fatal

    public void fatal(Marker marker,
                      Object message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `marker` - The marker data specific to this log statement.
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### fatal

    public void fatal(Marker marker,
                      String message)

  Description copied from interface: `Logger`
  Logs a message object with the `FATAL` level.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `marker` - The marker data specific to this log statement.
    `message` - the message object to log.

### fatal

    public void fatal(Marker marker,
                      String message,
                      Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the `FATAL` level.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `marker` - The marker data specific to this log statement.
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call.(RG) I assume you meant fatal, not info. It isn't possible to be misinterpreted as the previous method is for that signature. Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### fatal

    public void fatal(Marker marker,
                      String message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `marker` - The marker data specific to this log statement.
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### fatal

    public void fatal(Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `FATAL` level.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `msg` - the message string to be logged

### fatal

    public void fatal(Message msg,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `FATAL` level.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### fatal

    public void fatal(Object message)

  Description copied from interface: `Logger`
  Logs a message object with the `FATAL` level.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `message` - the message object to log.

### fatal

    public void fatal(Object message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### fatal

    public void fatal(String message)

  Description copied from interface: `Logger`
  Logs a message object with the `FATAL` level.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `message` - the message string to log.

### fatal

    public void fatal(String message,
                      Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the `FATAL` level.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call.(RG) I assume you meant fatal, not info. It isn't possible to be misinterpreted as the previous method is for that signature. Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### fatal

    public void fatal(String message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `fatal` in interface `Logger`
  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### getMessageFactory

    public MessageFactory getMessageFactory()

  Description copied from interface: `Logger`
  Gets the message factory used to convert message Objects and Strings into actual log Messages.

  Specified by:
    `getMessageFactory` in interface `Logger`
  Returns:
    the message factory.

### getName

    public String getName()

  Description copied from interface: `Logger`
  Gets the logger name.

  Specified by:
    `getName` in interface `Logger`
  Returns:
    the logger name.

### info

    public void info(Marker marker,
                     Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `INFO` level.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### info

    public void info(Marker marker,
                     Message msg,
                     Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `INFO` level.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### info

    public void info(Marker marker,
                     Object message)

  Description copied from interface: `Logger`
  Logs a message object with the `INFO` level.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### info

    public void info(Marker marker,
                     Object message,
                     Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### info

    public void info(Marker marker,
                     String message)

  Description copied from interface: `Logger`
  Logs a message object with the `INFO` level.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### info

    public void info(Marker marker,
                     String message,
                     Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the `INFO` level.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call. (RG) It isn't possible to be misinterpreted as the previous method is for that signature. Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### info

    public void info(Marker marker,
                     String message,
                     Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### info

    public void info(Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `INFO` level.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `msg` - the message string to be logged

### info

    public void info(Message msg,
                     Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `INFO` level.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### info

    public void info(Object message)

  Description copied from interface: `Logger`
  Logs a message object with the `INFO` level.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `message` - the message object to log.

### info

    public void info(Object message,
                     Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### info

    public void info(String message)

  Description copied from interface: `Logger`
  Logs a message object with the `INFO` level.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `message` - the message string to log.

### info

    public void info(String message,
                     Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the `INFO` level.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call. (RG) It isn't possible to be misinterpreted as the previous method is for that signature. Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### info

    public void info(String message,
                     Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `info` in interface `Logger`
  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### isDebugEnabled

    public boolean isDebugEnabled()

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the `DEBUG` Level.

  Specified by:
    `isDebugEnabled` in interface `Logger`
  Returns:
    boolean - `true` if this Logger is enabled for level DEBUG, `false` otherwise.

### isDebugEnabled

    public boolean isDebugEnabled(Marker marker)

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the `DEBUG` Level.

  Specified by:
    `isDebugEnabled` in interface `Logger`
  Parameters:
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level DEBUG, `false` otherwise.

### isEnabled

    public boolean isEnabled(Level level)

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the the given Level.

  Note that passing in `OFF` always returns `true`.

  Specified by:
    `isEnabled` in interface `Logger`
  Parameters:
    `level` - the level to check
  Returns:
    boolean - `true` if this Logger is enabled for level, `false` otherwise.

### isEnabled

    public boolean isEnabled(Level level,
                             Marker marker)

  Description copied from interface: `Logger`
  Checks whether this logger is enabled at the specified level and an optional Marker.

  Specified by:
    `isEnabled` in interface `Logger`
  Parameters:
    `level` - The Level to check.
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level `WARN`, `false` otherwise.

### isErrorEnabled

    public boolean isErrorEnabled()

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the `ERROR` Level.

  Specified by:
    `isErrorEnabled` in interface `Logger`
  Returns:
    boolean - `true` if this Logger is enabled for level `ERROR`, `false` otherwise.

### isErrorEnabled

    public boolean isErrorEnabled(Marker marker)

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the `ERROR` Level.

  Specified by:
    `isErrorEnabled` in interface `Logger`
  Parameters:
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level `ERROR`, `false` otherwise.

### isFatalEnabled

    public boolean isFatalEnabled()

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the `FATAL` Level.

  Specified by:
    `isFatalEnabled` in interface `Logger`
  Returns:
    boolean - `true` if this Logger is enabled for level `FATAL`, `false` otherwise.

### isFatalEnabled

    public boolean isFatalEnabled(Marker marker)

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the `FATAL` Level.

  Specified by:
    `isFatalEnabled` in interface `Logger`
  Parameters:
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level `FATAL`, `false` otherwise.

### isInfoEnabled

    public boolean isInfoEnabled()

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the `INFO` Level.

  Specified by:
    `isInfoEnabled` in interface `Logger`
  Returns:
    boolean - `true` if this Logger is enabled for level INFO, `false` otherwise.

### isInfoEnabled

    public boolean isInfoEnabled(Marker marker)

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the `INFO` Level.

  Specified by:
    `isInfoEnabled` in interface `Logger`
  Parameters:
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level INFO, `false` otherwise.

### isTraceEnabled

    public boolean isTraceEnabled()

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the `TRACE` level.

  Specified by:
    `isTraceEnabled` in interface `Logger`
  Returns:
    boolean - `true` if this Logger is enabled for level TRACE, `false` otherwise.

### isTraceEnabled

    public boolean isTraceEnabled(Marker marker)

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the `TRACE` level.

  Specified by:
    `isTraceEnabled` in interface `Logger`
  Parameters:
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level TRACE, `false` otherwise.

### isWarnEnabled

    public boolean isWarnEnabled()

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the `WARN` Level.

  Specified by:
    `isWarnEnabled` in interface `Logger`
  Returns:
    boolean - `true` if this Logger is enabled for level `WARN`, `false` otherwise.

### isWarnEnabled

    public boolean isWarnEnabled(Marker marker)

  Description copied from interface: `Logger`
  Checks whether this Logger is enabled for the `WARN` Level.

  Specified by:
    `isWarnEnabled` in interface `Logger`
  Parameters:
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level `WARN`, `false` otherwise.

### log

    public void log(Level level,
                    Marker marker,
                    Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the given level.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### log

    public void log(Level level,
                    Marker marker,
                    Message msg,
                    Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the given level.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### log

    public void log(Level level,
                    Marker marker,
                    Object message)

  Description copied from interface: `Logger`
  Logs a message object with the given level.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### log

    public void log(Level level,
                    Marker marker,
                    Object message,
                    Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### log

    public void log(Level level,
                    Marker marker,
                    String message)

  Description copied from interface: `Logger`
  Logs a message object with the given level.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### log

    public void log(Level level,
                    Marker marker,
                    String message,
                    Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the given level.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `Logger.getMessageFactory()`

### log

    public void log(Level level,
                    Marker marker,
                    String message,
                    Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### log

    public void log(Level level,
                    Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the given level.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `msg` - the message string to be logged

### log

    public void log(Level level,
                    Message msg,
                    Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the given level.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### log

    public void log(Level level,
                    Object message)

  Description copied from interface: `Logger`
  Logs a message object with the given level.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `message` - the message object to log.

### log

    public void log(Level level,
                    Object message,
                    Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### log

    public void log(Level level,
                    String message)

  Description copied from interface: `Logger`
  Logs a message object with the given level.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `message` - the message string to log.

### log

    public void log(Level level,
                    String message,
                    Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the given level.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `Logger.getMessageFactory()`

### log

    public void log(Level level,
                    String message,
                    Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `log` in interface `Logger`
  Parameters:
    `level` - the logging level
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### logIfEnabled

    public void logIfEnabled(String fqcn,
                             Level level,
                             Marker marker,
                             Message msg,
                             Throwable t)

  Description copied from interface: `ExtendedLogger`
  Logs a message if the specified level is active.

  Specified by:
    `logIfEnabled` in interface `ExtendedLogger`
  Parameters:
    `fqcn` - The fully qualified class name of the logger entry point, used to determine the caller class and method when location information needs to be logged.
    `level` - The logging Level to check.
    `marker` - A Marker or null.
    `msg` - The Message.
    `t` - the exception to log, including its stack trace.

### logIfEnabled

    public void logIfEnabled(String fqcn,
                             Level level,
                             Marker marker,
                             Object message,
                             Throwable t)

  Description copied from interface: `ExtendedLogger`
  Logs a message if the specified level is active.

  Specified by:
    `logIfEnabled` in interface `ExtendedLogger`
  Parameters:
    `fqcn` - The fully qualified class name of the logger entry point, used to determine the caller class and method when location information needs to be logged.
    `level` - The logging Level to check.
    `marker` - A Marker or null.
    `message` - The message.
    `t` - the exception to log, including its stack trace.

### logIfEnabled

    public void logIfEnabled(String fqcn,
                             Level level,
                             Marker marker,
                             String message)

  Description copied from interface: `ExtendedLogger`
  Logs a message if the specified level is active.

  Specified by:
    `logIfEnabled` in interface `ExtendedLogger`
  Parameters:
    `fqcn` - The fully qualified class name of the logger entry point, used to determine the caller class and method when location information needs to be logged.
    `level` - The logging Level to check.
    `marker` - A Marker or null.
    `message` - The message.

### logIfEnabled

    public void logIfEnabled(String fqcn,
                             Level level,
                             Marker marker,
                             String message,
                             Object... params)

  Description copied from interface: `ExtendedLogger`
  Logs a message if the specified level is active.

  Specified by:
    `logIfEnabled` in interface `ExtendedLogger`
  Parameters:
    `fqcn` - The fully qualified class name of the logger entry point, used to determine the caller class and method when location information needs to be logged.
    `level` - The logging Level to check.
    `marker` - A Marker or null.
    `message` - The message format.
    `params` - The message parameters.

### logIfEnabled

    public void logIfEnabled(String fqcn,
                             Level level,
                             Marker marker,
                             String message,
                             Throwable t)

  Description copied from interface: `ExtendedLogger`
  Logs a message if the specified level is active.

  Specified by:
    `logIfEnabled` in interface `ExtendedLogger`
  Parameters:
    `fqcn` - The fully qualified class name of the logger entry point, used to determine the caller class and method when location information needs to be logged.
    `level` - The logging Level to check.
    `marker` - A Marker or null.
    `message` - The message.
    `t` - the exception to log, including its stack trace.

### logMessage

    protected void logMessage(String fqcn,
                              Level level,
                              Marker marker,
                              Object message,
                              Throwable t)

### logMessage

    protected void logMessage(String fqcn,
                              Level level,
                              Marker marker,
                              String message,
                              Throwable t)

### logMessage

    protected void logMessage(String fqcn,
                              Level level,
                              Marker marker,
                              String message)

### logMessage

    protected void logMessage(String fqcn,
                              Level level,
                              Marker marker,
                              String message,
                              Object... params)

### printf

    public void printf(Level level,
                       Marker marker,
                       String format,
                       Object... params)

  Description copied from interface: `Logger`
  Logs a formatted message using the specified format string and arguments.

  Specified by:
    `printf` in interface `Logger`
  Parameters:
    `level` - The logging Level.
    `marker` - the marker data specific to this log statement.
    `format` - The format String.
    `params` - Arguments specified by the format.

### printf

    public void printf(Level level,
                       String format,
                       Object... params)

  Description copied from interface: `Logger`
  Logs a formatted message using the specified format string and arguments.

  Specified by:
    `printf` in interface `Logger`
  Parameters:
    `level` - The logging Level.
    `format` - The format String.
    `params` - Arguments specified by the format.

### throwing

    public <T extends Throwable> T throwing(T t)

  Description copied from interface: `Logger`
  Logs an exception or error to be thrown. This may be coded as:

           throw logger.throwing(myException);

  Specified by:
    `throwing` in interface `Logger`
  Type Parameters:
    `T` - the Throwable type.
  Parameters:
    `t` - The Throwable.
  Returns:
    the Throwable.

### throwing

    public <T extends Throwable> T throwing(Level level,
                                            T t)

  Description copied from interface: `Logger`
  Logs an exception or error to be thrown. This may be coded as:

           throw logger.throwing(Level.DEBUG, myException);

  Specified by:
    `throwing` in interface `Logger`
  Type Parameters:
    `T` - the Throwable type.
  Parameters:
    `level` - The logging Level.
    `t` - The Throwable.
  Returns:
    the Throwable.

### throwing

    protected <T extends Throwable> T throwing(String fqcn,
                                               Level level,
                                               T t)

  Logs a Throwable to be thrown.

  Type Parameters:
    `T` - the type of the Throwable.
  Parameters:
    `fqcn` - the fully qualified class name of this Logger implementation.
    `level` - The logging Level.
    `t` - The Throwable.
  Returns:
    the Throwable.

### throwingMsg

    protected Message throwingMsg(Throwable t)

### trace

    public void trace(Marker marker,
                      Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `TRACE` level.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### trace

    public void trace(Marker marker,
                      Message msg,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `TRACE` level.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### trace

    public void trace(Marker marker,
                      Object message)

  Description copied from interface: `Logger`
  Logs a message object with the `TRACE` level.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### trace

    public void trace(Marker marker,
                      Object message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.
  See Also:
    `Logger.debug(String)`

### trace

    public void trace(Marker marker,
                      String message)

  Description copied from interface: `Logger`
  Logs a message object with the `TRACE` level.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message string to log.

### trace

    public void trace(Marker marker,
                      String message,
                      Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the `TRACE` level.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `Logger.getMessageFactory()`

### trace

    public void trace(Marker marker,
                      String message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.
  See Also:
    `Logger.debug(String)`

### trace

    public void trace(Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `TRACE` level.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `msg` - the message string to be logged

### trace

    public void trace(Message msg,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `TRACE` level.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### trace

    public void trace(Object message)

  Description copied from interface: `Logger`
  Logs a message object with the `TRACE` level.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `message` - the message object to log.

### trace

    public void trace(Object message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.
  See Also:
    `Logger.debug(String)`

### trace

    public void trace(String message)

  Description copied from interface: `Logger`
  Logs a message object with the `TRACE` level.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `message` - the message string to log.

### trace

    public void trace(String message,
                      Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the `TRACE` level.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `Logger.getMessageFactory()`

### trace

    public void trace(String message,
                      Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `trace` in interface `Logger`
  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.
  See Also:
    `Logger.debug(String)`

### warn

    public void warn(Marker marker,
                     Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `WARN` level.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### warn

    public void warn(Marker marker,
                     Message msg,
                     Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `WARN` level.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### warn

    public void warn(Marker marker,
                     Object message)

  Description copied from interface: `Logger`
  Logs a message object with the `WARN` level.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### warn

    public void warn(Marker marker,
                     Object message,
                     Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### warn

    public void warn(Marker marker,
                     String message)

  Description copied from interface: `Logger`
  Logs a message object with the `WARN` level.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### warn

    public void warn(Marker marker,
                     String message,
                     Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the `WARN` level.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement.
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call. (RG) I assume you meant warn, not info. It isn't possible to be misinterpreted as the previous method is for that signature.Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### warn

    public void warn(Marker marker,
                     String message,
                     Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### warn

    public void warn(Message msg)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `WARN` level.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `msg` - the message string to be logged

### warn

    public void warn(Message msg,
                     Throwable t)

  Description copied from interface: `Logger`
  Logs a message with the specific Marker at the `WARN` level.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### warn

    public void warn(Object message)

  Description copied from interface: `Logger`
  Logs a message object with the `WARN` level.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `message` - the message object to log.

### warn

    public void warn(Object message,
                     Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### warn

    public void warn(String message)

  Description copied from interface: `Logger`
  Logs a message object with the `WARN` level.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `message` - the message string to log.

### warn

    public void warn(String message,
                     Object... params)

  Description copied from interface: `Logger`
  Logs a message with parameters at the `WARN` level.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call. (RG) I assume you meant warn, not info. It isn't possible to be misinterpreted as the previous method is for that signature.Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### warn

    public void warn(String message,
                     Throwable t)

  Description copied from interface: `Logger`
  Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.

  Specified by:
    `warn` in interface `Logger`
  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2015 Apache Software Foundation. All Rights Reserved.
Apache Logging, Apache Log4j, Log4j, Apache, the Apache feather logo, the Apache Logging project logo, and the Apache Log4j logo are trademarks of The Apache Software Foundation.